﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ButtonToolCommand
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }

    public delegate void  CommandDelegate ();

    public class DelegatedCommand : ICommand
    {
        private CommandDelegate commandDelegate;

        public DelegatedCommand(CommandDelegate command)
        {
            commandDelegate = command;
        }

        public bool CanExecute(object parameter)
        {
            return true;
        }

        public event EventHandler CanExecuteChanged;

        public void Execute(object parameter)
        {
            commandDelegate();
        }
    }

    public class MainVM
    {
        private ICommand commnad1;
        public ICommand Command1
        {
            get
            {
                if (commnad1 == null)
                {
                    commnad1 = new DelegatedCommand(CommandMethod1);
                }

                return commnad1;
            }
        }
        private ICommand commnad2;
        public ICommand Command2
        {
            get
            {
                if (commnad2 == null)
                {
                    commnad2 = new DelegatedCommand(CommandMethod2);
                }

                return commnad2;
            }
        }

        public void CommandMethod1()
        {
            MessageBox.Show("Button 1 was clicked!");
        }

        public void CommandMethod2()
        {
            MessageBox.Show("Button 2 was clicked!");
        }
    }
}
